<?php
/**
 * Jonah external API interface.
 *
 * $Horde: jonah/lib/api.php,v 1.58 2005/12/25 19:37:24 chuck Exp $
 *
 * This file defines Jonah's external API interface. Other
 * applications can interact with Jonah through this API.
 *
 * @package Jonah
 */

$_services['perms'] = array(
    'args' => array(),
    'type' => '{urn:horde}stringArray'
);

$_services['story'] = array(
    'args' => array('channel' => 'int',
                    'story' => 'int'),
    'type' => '{urn:horde}stringArray'
);

$_services['commentCallback'] = array(
    'args' => array('story_id' => 'string'),
    'type' => 'string'
);

$_services['hasComments'] = array(
    'args' => array(),
    'type' => 'boolean'
);

function _jonah_perms()
{
    require_once dirname(__FILE__) . '/base.php';
    require_once JONAH_BASE . '/lib/News.php';

    $news = &Jonah_News::singleton();
    $channels = $news->getChannels(JONAH_INTERNAL_CHANNEL);

    /* Loop through internal channels and add their ids to the
     * perms. */
    $perms = array();
    foreach ($channels as $channel) {
        $perms['tree']['jonah']['news']['internal_channels'][$channel['channel_id']] = false;
    }

    /* Human names. */
    $perms['title']['jonah:news'] = _("News");
    $perms['title']['jonah:news:internal_channels'] = _("Internal Channels");

    /* Loop through internal channels and add them to the perms
     * titles. */
    foreach ($channels as $channel) {
        $perms['title']['jonah:news:internal_channels:' . $channel['channel_id']] = $channel['channel_name'];
    }

    $channels = $news->getChannels(JONAH_EXTERNAL_CHANNEL);

    /* Loop through external channels and add their ids to the
     * perms. */
    foreach ($channels as $channel) {
        $perms['tree']['jonah']['news']['external_channels'][$channel['channel_id']] = false;
    }

    /* Human names. */
    $perms['title']['jonah:news'] = _("News");
    $perms['title']['jonah:news:external_channels'] = _("External Channels");

    /* Loop through external channels and add them to the perms
     * titles. */
    foreach ($channels as $channel) {
        $perms['title']['jonah:news:external_channels:' . $channel['channel_id']] = $channel['channel_name'];
    }

    $perms['tree']['jonah']['admin'] = array();
    $perms['title']['jonah:admin'] = _("Administrator");

    return $perms;
}

function _jonah_story($channel_id, $story_id)
{
    require_once dirname(__FILE__) . '/base.php';
    require_once JONAH_BASE . '/lib/News.php';

    $news = &Jonah_News::singleton();
    return $news->getStory($channel_id, $story_id, true);
}

function _jonah_commentCallback($story_id)
{
    if (!$GLOBALS['conf']['comments']['allow']) {
        return false;
    }

    require_once dirname(__FILE__) . '/base.php';
    require_once JONAH_BASE . '/lib/News.php';

    $news = &Jonah_News::singleton();
    $story = $news->getStory(null, $story_id);
    if (is_a($story, 'PEAR_Error')) {
        return false;
    }

    return $story['story_title'];
}

function _jonah_hasComments()
{
    return $GLOBALS['conf']['comments']['allow'];
}
